# ITradingCallbacks

*Contains the types for the GNSTradingCallbacks facet*

## TradingCallbacksStorage

```solidity
struct TradingCallbacksStorage {
  uint8 vaultClosingFeeP;
  uint248 __placeholder;
  mapping(uint8 => uint256) pendingGovFees;
  uint256[48] __gap;
}
```

## CancelReason

```solidity
enum CancelReason {
  NONE,
  PAUSED,
  MARKET_CLOSED,
  SLIPPAGE,
  TP_REACHED,
  SL_REACHED,
  EXPOSURE_LIMITS,
  PRICE_IMPACT,
  MAX_LEVERAGE,
  NO_TRADE,
  WRONG_TRADE,
  NOT_HIT,
  LIQ_REACHED
}
```

## AggregatorAnswer

```solidity
struct AggregatorAnswer {
  struct ITradingStorage.Id orderId;
  uint256 spreadP;
  uint64 price;
  uint64 open;
  uint64 high;
  uint64 low;
}
```

## Values

```solidity
struct Values {
  int256 profitP;
  uint256 executionPrice;
  uint256 liqPrice;
  uint256 amountSentToTrader;
  uint256 collateralPriceUsd;
  bool exactExecution;
  uint256 collateralLeftInStorage;
  uint256 oraclePrice;
  uint32 limitIndex;
  uint256 priceImpactP;
}
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.gains.trade/developer/technical-reference/contracts/interfaces/types/itradingcallbacks.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
